#include <stdio.h>
#include "jcgi.h"
#include <stdlib.h>
#include <time.h>
char	deco(char what1 , char what2)
{
	register char	digit;
	digit = (what1 >= 'A' ? ((what1 & 0xdf) - 'A') + 10 : (what1 - '0'));
	digit *= 16;
	digit += (what2 >= 'A' ? ((what2 & 0xdf) - 'A') + 10 : (what2 - '0'));
	return digit;
}


/* ind && escape stolen but completely modyfied from NCSA code 
 */

int	ind(char *s, char c) 
{
	register int	x;
	if (c == '\n') 
		return 1;
	for (x = 0;s && s[x]; x++)
		if (s[x] == c) 
			return 1;
	return 0;
}


char	*escape_string(char *str,char *scapes) 
{
	register int	i, j = 0;
	char	*new;
        if(str==NULL) return NULL;
	for (j = 0, i = 0;str &&  str[i]; i++, j++)
		if (ind(scapes, str[i])) 
			j += 2;
	new = malloc(j * sizeof(char) + 1);
	for (j = 0, i = 0;str && str[i]; i++, j++) {
		if (ind(scapes, str[i])) {
			c2x(str[i], &new[j]);
			j += 2;
		} else 
			new[j] = str[i];
	}
	new[j] = '\0';
	return new;
}

char	*unescape_string(char *str) 
{
char *ptr=str;
int i,j;
char *ret;
if(str==NULL || !strlen(str)) return NULL;
ret=(char*)malloc(sizeof(char)*(strlen(str)+1));
for(i=0,j=0;ptr && ptr[i];i++,j++) {
ret[j]=ptr[i];
  if(ptr[i]=='%') {
        ret[j]= deco(ptr[i+1], ptr[i+2]);
  i=i+2;
  }
}
ret[j]='\0';
return ret;
}


Form *ReadIn()
{
	Form * this;
	if (!mystrncasecmp(REQUEST_METHOD, "POST", 4) && 
	    !mystrncasecmp(CONTENT_TYPE, "application/x-www-form-urlencoded", 33)) {
		int	length;
		char	*buf=(char*)NULL;
		length = atoi(CONTENT_LENGTH);
		buf = malloc(sizeof(char) *length + 1);
		if (buf == NULL) 
			return NULL;
		fread(buf, sizeof(char), length, stdin);
		if (!strlen(buf)) 
			return NULL;
		this = AppendFromString(buf, 0);
                free(buf);
	} else if (!mystrncasecmp(REQUEST_METHOD, "GET", 3)) {

		this = AppendFromString(QUERY_STRING, 0);
	} else
		return NULL;
	return this;
}


int	Measure(char *string)
{
	int	i = 0;
	while (*string != '=' && *string != '&' && *string != '\0') {
		if (*string == '%')
			string = string + 2;
		string++;
		i++;
	}
	return i;
}


Form *AppendFromString(char *string, int uncoded)
{
	Form * this;
	Form * *that = &this;
	char	*s = string;
	int	val = 0;
	int	i = 0;
        if (string==NULL) return (Form*)NULL;
        if (!strlen(string)) return (Form*)NULL;
	if (s == NULL) 
		return (Form*)NULL;
	while (*s != '\0') {
		if (!val) {
			*that = (Form * ) malloc(sizeof(Form));
			if (*that == NULL) 
				return (Form*)NULL;
			(*that)->next = NULL;
			(*that)->val = NULL;
			(*that)->field = NULL;
		}
		if (val) {
			(*that)->val = malloc((Measure(s) * sizeof(char) + 1));
			if ((*that)->val == NULL) 
				return (Form*)NULL;
		} else {
			(*that)->field = malloc((Measure(s) * sizeof(char) + 1));
			if ((*that)->field == NULL) 
				return (Form*)NULL;
		}
		i = 0;
		while (*s != '&' && *s != '=' && *s != '\0') {
			if (val) {
				switch (*s) {
				case '+':
					(*that)->val[i] = ' ';
					break;
				case '%':
					if (!uncoded) {
						(*that)->val[i] = deco(s[1], s[2]);
						s += 2;
					} else 
						(*that)->val[i] = *s;
					break;
				default:
					(*that)->val[i] = *s;
				}
			} else
				switch (*s) {
				case '+':
					(*that)->field[i] = ' ';
					break;
				case '%':
					(*that)->field[i] = deco(s[1], s[2]);
					s += 2;
					break;
				default:
					(*that)->field[i] = *s;
				}
			i++;
			s++;
		}
		if (val) {
			val = 0;
			(*that)->val[i] = '\0';
			that = &((*that)->next);
		} else {
			val = 1;
			(*that)->field[i] = '\0';
		}
		if (*s != '\0') 
			s++;
	}
	return this;
}


Form *Next(Form *this)
{
	return this->next;
}


Form *FSkip(Form *this, int n)
{
	int	i;
	Form * ret=this;
	for (i = 0; (i < n && ret != NULL); i++) 
		ret = ret->next;
	return ret;
}


void FreeForm(Form *this)
{
  Form *sledo;
  while (this) {
    if (this->field) free(this->field);
    if (this->val) free(this->val);
    sledo = this->next;
    free(this);
    this = sledo;
  }
}


Form *Field(Form *this, char *fld)
{
	Form * that = this;
        if(fld==NULL) return (Form*)NULL;
	while (that != NULL) {
		if ( mystrcmp(that->field, fld) == 0)
			return that;
		that = that->next;
	}
	return (Form * )NULL;
}


char	*Value(Form *this, char *fld)
{
	Form * that = Field(this, fld);
	if (that != NULL && that->val && strlen(that->val))
		return that->val;
	else
		return NULL;
}


char	**Values(Form *this, char *fld)
{
	char	**ret = (char**)NULL;
	int	i = 0;
	Form * that = Field(this, fld);
	if (that == (Form*)NULL) 
		return (char**)NULL;
	this = that;
	while (that != NULL) {
		if ( mystrcmp(that->field, fld) == 0) 
			i++;
		that = that->next;
	}
	that = this;
	ret = (char * *) malloc(sizeof(char * ) *(i + 1));
	i = 0;
	while (that != NULL) {
		if ( mystrcmp(that->field, fld) == 0) {
			ret[i] = that->val; 
			i++;
		}
		that = that->next;
	}
	ret[i] = NULL;
	return ret;
}


char	**ValuesII(Form *this, char *fld)
{
	char	**ret = (char**)NULL;
	int	i = 0;
	Form * that = Field(this, fld);
	if (that == (Form*)NULL) 
		return (char**)NULL;
	this = that;
	while ( mystrcmp(that->field, fld) == 0) {
		i++;
		that = that->next;
	}
	that = this;
	ret = (char * *) malloc(sizeof(char * ) *(i + 1));
	i = 0;
	while ( mystrcmp(that->field, fld) == 0) {
		ret[i] = that->val; 
		i++;
		that = that->next;
	}
	ret[i] = NULL;
	return ret;
}

char	*LastValue(Form *this, char *fld)
{
int i;
char *ret;
char **vls;
   if (this == (Form*)NULL || fld == NULL || !strlen(fld)) return NULL;
vls=Values(this,fld);
if(!vls) return NULL;
for(i=0;vls && vls[i];)i++;
i--;
if(vls[i]==NULL) return NULL;
ret=(char*)malloc(sizeof(char)*(strlen(vls[i])+1));
sprintf(ret,"%s",vls[i]);
return ret;
}

		

static char fordate[50];

char * CharGMTime	(time_t tim)
{
	char	*ret = fordate;
	struct tm *piu;
	piu = gmtime(&tim);
	sprintf(ret, "%d, %d-%d-%d %d:%d:%d GMT",
	    piu->tm_wday, piu->tm_mday, piu->tm_mon,
	    piu->tm_year, piu->tm_hour, piu->tm_min, piu->tm_sec);
	return ret;
}


char * CharTime	(time_t tim)
{
  /*	char	*month[] = {
		"January", "February", "March", "April",
		"May", "June", "July", "August", "September",
		"October", "November", "December"	};*/
  /*char	*ret = (char*)malloc(sizeof(char)*25);*/
        char *ret=fordate;
	struct tm *piu;
        if(tim==15) {
	sprintf(ret, "dd/mm/yy"); return ret;
	}
	piu = localtime(&tim);
	/*   sprintf(ret,"%d/%s/%d %d:%d:%d",
   piu->tm_mday,month[piu->tm_mon],
     piu->tm_year,piu->tm_hour,piu->tm_min,piu->tm_sec);*/
	sprintf(ret, "%d/%d/%d",
	    piu->tm_mday, piu->tm_mon + 1, piu->tm_year);
	return ret;
}


time_t	TimeFromString(char *string)
{
	struct tm piu;
	char	*ptr = string;
	char	sp[3];
	int	i = 0;
	if (string == NULL) 
		return 15;
	while ((*ptr == ' ') || (*ptr == '\r') || (*ptr == '\n')) 
		ptr++;
	if (*ptr == '\0') 
		return 15;
	if (strlen(string) <= 5) 
		return 15;
	if (*ptr == 92 || *ptr == 47) 
		ptr++;
	sp[i] = *ptr; 
	ptr++; 
	if (!isdigit(sp[i])) 
		return 15;
	i++;
	if (*ptr != 92 && *ptr != 47) {
		sp[i] = *ptr; 
		ptr++; 
		if (!isdigit(sp[i])) 
			return 15; 
		i++;
	}
	sp[i] = '\0'; 
	piu.tm_mday = matoi(sp); 
	if (piu.tm_mday > 31 || piu.tm_mday < 0) 
		return 15;
	ptr++;
	i = 0;
	sp[i] = *ptr; 
	ptr++; 
	if (!isdigit(sp[i])) 
		return 15;
	i++;
	if (*ptr != 92 && *ptr != 47) {
		sp[i] = *ptr; 
		ptr++; 
		if (!isdigit(sp[i])) 
			return 15; 
		i++;
	}
	sp[i] = '\0'; 
	piu.tm_mon = matoi(sp) - 1; 
	if (piu.tm_mon > 12 || piu.tm_mon < 0) 
		return 15;
	ptr++;
	i = 0;
	sp[i] = *ptr; 
	ptr++; 
	if (!isdigit(sp[i])) 
		return 15;
	i++;
	if (*ptr != 92 && *ptr != 47) {
		sp[i] = *ptr; 
		ptr++; 
		if (!isdigit(sp[i])) 
			return 15; 
		i++;
	}
	sp[i] = '\0'; 
	piu.tm_year = matoi(sp); 
	if (piu.tm_year > 99 || piu.tm_year < 70) 
		return 15;
	piu.tm_sec = 0;
	piu.tm_min = 0;
	piu.tm_hour = 0;
	piu.tm_wday = 0;
	piu.tm_yday = 0;
	piu.tm_isdst = 1;
	return mktime(&piu);
}


time_t	Ago(int days)
{
	long int	tim = time(NULL);
	return tim - days * 24 * 3600;
}










